<?php

class Admin_ManageCategories extends SmugPress {
	var $categories_value;
	function __construct() {
		add_action('wp_ajax_subcategories_get_manage', array(&$this,'subcategories_get_manage_callback'));
		add_action('admin_menu',array(&$this,'create_menu_item'),10);
		if($_GET['page'] == 'smugmug-manage-categories') {
			add_action('admin_head', array(&$this,'smp_manage_categories_javascript'),99);
		}
	}
	public function renderer($layout=false) {
		$this->class = get_class();
		$this->render($layout,$this->class);
	}
	public function smp_manage_categories_javascript() {
		$this->renderer('javascript');
	}
	
	function subcategories_get_manage_callback() {
		global $f;
		$category_id = $_POST['category_id'];
		$subcategory_id = $_POST['subcategory_id'];
		
		if($category_id != 'new') {
			$subcategories = $f->subcategories_get("CategoryID=".$category_id);
			if($subcategories) {
				echo '<option value="">Select Sub Category</option>';
				echo '<option value="0">None</option>';
				for($i = 0; $i < count($subcategories); $i++) {
					if($subcategory_id == $subcategories[$i]['id']) {
						echo '<option selected="selected" value="'.$subcategories[$i]['id'].'">'.$subcategories[$i]['Name'].'</option>';
					} else {
						echo '<option value="'.$subcategories[$i]['id'].'">'.$subcategories[$i]['Name'].'</option>';
					}
				}
				echo '<option value="new">Create New</option>';
			} else {
				echo '<option value=""></option>';
				echo '<option value="0">None</option>';
			}
			
		} else {
			echo '<option value=""></option>';
			echo '<option value="0">None</option>';
		}
		
		die();
	}
	
	public static function smugpress_field_creation($params,$options,$type) {
		switch($type)
		{
			case 'text':
				$name = $params['name'];
				echo "<input id='".$params['name']."' name='".$params['name']."' size='50' type='text' value='".$options[$name]."' />";
				break;
			case 'textarea':
				$name = $params['name'];
				echo "<textarea id='".$params['name']."' name='".$params['name']."' rows='5' cols='40'>".$options[$name]."</textarea>";
				break;
			//case 'radio':
			case 'boolean':
				$name = $params['name'];
				if($options[$name] == 1) {
					echo '<input type="radio" name="'.$params['name'].'" value="1" checked="checked" />Yes <input type="radio" name="'.$params['name'].'" value="0" />No';
				} else {
					echo '<input type="radio" name="'.$params['name'].'" value="1" />Yes <input type="radio" checked="checked" name="'.$params['name'].'" value="0" />No';
				}
				break;
			case 'checkbox':
				foreach($params['names'] as $name) {
					if($options[$name] == 1) {
						echo '<input type="checkbox" name="'.$name.'" value="1" checked="checked" /> '.$name.' ';
					} else {
						echo '<input type="checkbox" name="'.$name.'" value="1" /> '.$name.' ';
					}
				}
				break;
			case 'radio':
				$last_element = end($params['values']);
				foreach($params['values'] as $value) {
					$name = $params['name'];
					
					if($options[$name] == $value['value']) {
						echo '<input checked="checked" type="radio" name="'.$params['name'].'" value="'.$value['value'].'"> '.$value['title'].' <span class="description">'.$value['description'].'</span>';
					} else {
						echo '<input type="radio" name="'.$params['name'].'" value="'.$value['value'].'"> '.$value['title'].' <span class="description">'.$value['description'].'</span>';
					}
					if($last_element['title'] != $value['title']) {
						echo '<br />';
					}
				}
				break;
			case 'select':
				$name = $params['name'];
				if(array_key_exists('sub_array_item',$params)) {
					echo '<select id="'.$params['name'].'" name="'.$params['name'].'">';
				} else {
					echo '<select id="'.$params['name'].'" name="'.$params['name'].'">';
				}
				
				//echo '<option value="">&nbsp;</option>';
				foreach($params['value'] as $param) {
					if($options == $param['value']){
						echo '<option value="'.$param['value'].'" selected="selected">'.$param['name'].'</option>';
					} else {
						echo '<option value="'.$param['value'].'">'.$param['name'].'</option>';
					}
					
				}
				echo '</select>';
				break;
		}
	}
	public function create_menu_item() {
		add_submenu_page('smugmug-plugin','Manage Categories | SmugMug','Manage Categories','manage_options',
			'smugmug-manage-categories',array(&$this,'manage_categories_view'));
	}
	public function category_submit($post) {
		global $f;
		$form_type = $_POST['FormType'];
		switch($_POST['FormType']) {
			case 'category-create':
				$response = $f->categories_create(array('Name' => $_POST['Name'], 'NiceName' => $_POST['NiceName']));
				echo $form_type;
				break;
			case 'category-delete':
				$response = $f->categories_delete(array('CategoryID' => $_POST['CategoryID']));
				echo $form_type;
				break;
			case 'category-rename':
				$changed = array('CategoryID' => (int)$_POST['CategoryID'],'Name' => $_POST['Name']);
				print_r($changed);
				$response = $f->categories_rename($changed);
				echo $form_type;
				break;
			case 'subcategory-create':
				$response = $f->subcategories_create(array('CategoryID' => $_POST['CategoryID'],'Name' => $_POST['Name'],'NiceName' => $_POST['NiceName']));
				echo $form_type;
				break;
			case 'subcategory-delete':
				$response = $f->subcategories_delete(array('SubCategoryID' => $_POST['SubCategoryID']));
				echo $form_type;
				break;
			case 'subcategory-rename':
				$response = $f->subcategories_rename(array('SubCategoryID' => $_POST['SubCategoryID'],'Name' => $_POST['Name'],'NiceName' => $_POST['NiceName']));
				echo $form_type;
				break;
		}
		return $response;
	}
	function manage_categories_view() {
		global $f;
		if($_POST) {
			$response = $this->category_submit($_POST);
			print_r($response);
		}
		$categories = $f->categories_get(array('Associative' => 1));
		//print_r($categories);
		$i = 0;
		foreach($categories as $key => $category) {
			if($category['Type'] == 'User') {
				$this->categories_custom[$i]['value'] = $category['id'];
				$this->categories_custom[$i]['name'] = $category['Name'];
			}
			$this->categories_value[$i]['value'] = $category['id'];
			$this->categories_value[$i]['name'] = $category['Name'];
			$i++;
		}
		//for($i = 0; $i < count($categories); $i++) {
			
		//}
		//echo '<pre>';
		//print_r($this->categories_value);
		//echo '</pre>';
		$this->renderer('manage-categories');
	}
}
global $manage_categories;
$manage_categories = new Admin_ManageCategories();
