<?php

class Admin_Settings_Authorization extends Admin_Settings {
	var $auth_key;
	function __construct() {
            add_action('wp_ajax_remove_auth', array(&$this,'remove_auth_callback'));
            add_action('admin_footer',array(&$this,'smp_footer_script'));
            $this->auth_key = get_option('smugpress_access_token');
            $this->smug_auth = unserialize(get_option('smugpress_authorization'));
	}
	public function renderer($layout=false) {
            $this->class = get_class();
            $this->render($layout,$this->class);
	}
	public function authorize_smugpress() {
            global $f;
		try {
                    if ( ! isset( $_SESSION['SmugGalReqToken'] ) ) {
                        // Step 1: Get a Request Token
                        $d = $f->auth_getRequestToken();
                        $_SESSION['SmugGalReqToken'] = serialize( $d );

                        // Step 2: Get the User to login to SmugMug and Authorise this demo
                        echo "<p>Click <a href='".$f->authorize("Access=Full", "Permissions=Modify")."&iframe=true&width=900' rel='prettyPhoto' title='IF YOU CANT SEE THE ENTIRE LOGIN SCREEN, CLICK THE EXPAND BUTTON ON THE TOP RIGHT'><strong>HERE</strong></a> to Authorize This Plugin to Access Your SmugMug Account.</p>";
                        echo "<p>A new window/tab will open asking you to login to SmugMug (if not already logged in).  Once you've logged it, SmugMug will redirect you to a page asking you to approve the access (it's read only) to your public photos.  Approve the request and come back to this page and click REFRESH below.</p>";
                        echo "<p><a href='".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']."'><strong>REFRESH</strong></a></p>";
                    } else {
                        $reqToken = unserialize( $_SESSION['SmugGalReqToken'] );
                        unset( $_SESSION['SmugGalReqToken'] );
                        $_SESSION = array();
                        // Step 3: Use the Request token obtained in step 1 to get an access token
                        $f->setToken("id={$reqToken['Token']['id']}", "Secret={$reqToken['Token']['Secret']}");
                        $token = $f->auth_getAccessToken();	// The results of this call is what your application needs to store.

                        $serialized_token = serialize($token);

                        add_option('smugpress_access_token',$serialized_token);

                        $token_new = unserialize(get_option('smugpress_access_token'));
                        // Set the Access token for use by phpSmug.   
                        $f->setToken( "id={$token_new['Token']['id']}", "Secret={$token_new['Token']['Secret']}" );

                        // Get list of public albums
                        $albums = $f->albums_get( 'Heavy=True' );
                        // Get list of public images and other useful information

                        $images = $f->images_get( "AlbumID={$albums['0']['id']}", "AlbumKey={$albums['0']['Key']}", "Heavy=1" );

                        $images_slice = array_slice($images['Images'],0,10);

                        echo '<p>If you see any images below, Wordpress has successfully connected to your SmugMug account.</p>';

                        // Display the thumbnails and link to the Album page for each image
                        foreach ( $images_slice as $image ) {
                                echo '<img src="'.$image['TinyURL'].'" title="'.$image['Caption'].'" alt="'.$image['id'].'" />';

                        }
                        echo '<p><strong>Refresh this Page</strong></p>';
                    }
            }
            catch ( Exception $e ) {
                if ($e->getCode() == 36) {
                    echo "<div id='message' class='error'><p><strong>Expired Token (Refresh this Page)</strong></p></div>";
                } else {
                    echo "<div id='message' class='error'><p><strong>Not Successful</strong></p><p>{$e->getMessage()} (Error Code: {$e->getCode()})</p></div>";
                }

            }
	}
	public function remove_auth_callback() {
            if( ! delete_option('smugpress_access_token') ) {
                echo '<div id="message" class="error"><p><strong>Update Didn\'t Work</strong></p><p>Your SmugMug authorization wasn\'t removed.</p></div>';
            } else {
                echo '<div id="message" class="updated"><p><strong>Success!</strong></p><p>Your SmugMug authorization has been successfully removed.</p></div>';
                $this->authorize_smugpress();
            }
		
            die();
	}
	public function remove_authorization() {
            
	}
	function create_section() {
            $this->renderer('authorization');
	}
}
//global $authorization;
//$authorization = new Admin_Settings_Authorization();
