<?php

class Admin_Settings_Frontend extends Admin_Settings {
    function __construct() {
        add_action('wp_ajax_settings_frontend', array(&$this,'settings_frontend_callback'));
        $this->forms = new Admin_Forms( $this->smp_settings_meta_boxes() );
    }
    public function renderer($layout=false) {
        $this->class = get_class();
        $this->render($layout,$this->class);
    }
    function create_section() {
       if(get_option('smugpress_access_token')) {
            $this->renderer('frontend');
       }
        
    }
    function settings_meta_boxes() {
        
        $meta_boxes = $this->smp_settings_meta_boxes();
        
        $this->forms->smp_form_table($meta_boxes,2,false);
        
    }
    function settings_frontend_callback() {
        
        $posted_data = explode("&", $_POST['form_data']);
        
        $this->forms->save_form_ajax($posted_data);
        
        //echo $form_save;
        
        //if($form_save) {
            //echo '<div id="message" class="error"><p><strong>Update Didn\'t Work</strong></p><p>Your settings weren\'t saved.</p></div>';
        //} else {
            echo '<div id="message" class="updated"><p><strong>Success!</strong></p><p>Your settings have been Saved.</p></div>';
        //}
        
        die();
    }
    function smp_settings_meta_boxes() {
        $pretty_photo_styles = array(
            array( 'name' => 'Default', 'value' => 'pp_default' ),
            array( 'name' => 'Light Rounded', 'value' => 'light_rounded' ),
            array( 'name' => 'Dark Rounded', 'value' => 'dark_rounded' ),
            array( 'name' => 'Light Square', 'value' => 'light_square' ),
            array( 'name' => 'Dark Square', 'value' => 'dark_square' ),
            array( 'name' => 'Facebook', 'value' => 'facebook' ),
        );
        $animation_speeds = array(
            array( 'name' => 'Fast', 'value' => 'fast' ),
            array( 'name' => 'Normal', 'value' => 'normal' ),
            array( 'name' => 'Slow', 'value' => 'slow' ),
        );
        $opacity = array(
            array( 'name' => '1.0', 'value' => '1.0' ),
            array( 'name' => '0.9', 'value' => '0.9' ),
            array( 'name' => '0.8', 'value' => '0.8' ),
            array( 'name' => '0.7', 'value' => '0.7' ),
            array( 'name' => '0.6', 'value' => '0.6' ),
            array( 'name' => '0.5', 'value' => '0.5' ),
            array( 'name' => '0.4', 'value' => '0.4' ),
            array( 'name' => '0.3', 'value' => '0.3' ),
            array( 'name' => '0.2', 'value' => '0.2' ),
            array( 'name' => '0.1', 'value' => '0.1' ),
            array( 'name' => '0.0', 'value' => '0.0' ),
        );
        /* Array of the meta box options. */
        $meta_boxes = array(
           'pretty_photo_template' => array( 'name' => 'smp_lightbox_template', 'options' => $pretty_photo_styles, 'title' => __('Lightbox Template', 'smp'), 'type' => 'select' ),
           'pretty_photo_overlay' => array( 'name' => 'smp_lightbox_overlay', 'title' => __('Overlay Gallery', 'smp'), 'type' => 'boolean', 'description' => 'If set to true, a gallery will overlay the fullscreen image on mouse over.' ),
           'pretty_photo_autoplay_slideshow' => array( 'name' => 'smp_lightbox_auto_slide', 'title' => __('Autoplay Slideshow', 'smp'), 'type' => 'boolean' ),
            'pretty_photo_keyboard_shortcuts' => array( 'name' => 'smp_lightbox_keyboard_shortcuts', 'title' => __('Keyboard Shortcuts', 'smp'), 'type' => 'boolean' ),
           'pretty_photo_allow_resize' => array( 'name' => 'smp_lightbox_allow_resize', 'title' => __('Allow Resize', 'smp'), 'type' => 'boolean', 'description' => 'Resize the photos bigger than viewport.' ),
           'pretty_photo_animation' => array( 'name' => 'smp_lightbox_animation', 'options' => $animation_speeds, 'title' => __('Animation Speed', 'smp'), 'type' => 'select' ),
           'pretty_photo_slideshow' => array( 'name' => 'smp_lightbox_slideshow', 'title' => __('Slideshow Speed', 'smp'), 'type' => 'text', 'description' => 'Amount of time between pictures in slideshow in miliseconds.' ),
           'pretty_photo_show_title' => array( 'name' => 'smp_lightbox_show_title', 'title' => __('Show Title', 'smp'), 'type' => 'boolean' ),
           'pretty_photo_opacity' => array( 'name' => 'smp_lightbox_opacity', 'options' => $opacity, 'title' => __('Slideshow Speed', 'smp'), 'type' => 'select' ),
            //'album' => array( 'name' => 'smp_album_id_key', 'options' => $this->albums, 'title' => __('Album', 'smp'), 'type' => 'select' ),
            //'album_template' => array( 'name' => 'smp_album_template', 'options' => $this->templates, 'title' => __('Album Template', 'smp'), 'type' => 'select' ),

        );

        return apply_filters( 'smp_post_meta_boxes', $meta_boxes );
    }
}