<?php
/*
Plugin Name: SmugMug for Wordpress
Plugin URI: http://www.quantumdevonline.com/smugmug-for-wordpress/
Description: This plugin integrates the SmugMug API with Wordpress.
Author: Anthony Humes
Version: 0.1.1
Author URI: http://www.quantumdevonline.com/

Copyright 2011 by Anthony Humes

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

if(!session_id())
session_start();

if(!class_exists('phpSmug')) {
	require_once( "phpSmug/phpSmug.php" );
}

 if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die('You are not allowed to call this page directly.'); }

class SmugPress {
	var $layoutFolder;
	
	public function SmugPress() {
		$this->__construct();
		
	}
	public function __construct() {
		global $manage_album;
                DEFINE('API_KEY','E8iGXpLViTw02u3j84HPvssubUiMPnc0');
                DEFINE('SECRET_KEY','1eb7da3f4eb60f9e045bde78c0596050');

                DEFINE('PLUGIN_DIR',WP_PLUGIN_DIR.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)));
                DEFINE('PLUGIN_URL',plugins_url('/smugmug/'));
                $template_dir = get_template_directory() . '/smugmug/';

                //echo($template_dir);
                if(is_dir($template_dir)) {
                        DEFINE('TEMPLATE_DIR',$template_dir);
                        DEFINE('TEMPLATE_URL', get_bloginfo('stylesheet_directory') . '/smugmug/');
                } else {
                        DEFINE('TEMPLATE_DIR',PLUGIN_DIR . 'templates/');
                        DEFINE('TEMPLATE_URL',PLUGIN_URL . 'templates/');
                }
                register_activation_hook( __FILE__, array(&$this,'activation') );
		add_action('plugins_loaded',array(&$this,'admin_init'));
		add_action('admin_menu',array(&$this,'admin_menu'));
		add_action('admin_enqueue_scripts', array(&$this,'load_custom_wp_admin_scripts'));
		add_filter('plugin_action_links', array(&$this, 'add_settings_link'), 10, 2 );
		if(!is_admin()) {
                    add_action('wp_enqueue_scripts',array(&$this,'smp_front_end_scripts_styles'));
                    add_action('wp_print_footer_scripts',array(&$this,'smp_front_footer_script'));
		}
	}
        
        public function activation() {
            $default_options = array(
                'smp_lightbox_template' => 'pp_default',
                'smp_lightbox_overlay' => 1,
                'smp_lightbox_auto_slide' => 0,
                'smp_lightbox_keyboard_shortcuts' => 1,
                'smp_lightbox_allow_resize' => 1,
                'smp_lightbox_animation' => 'fast',
                'smp_lightbox_slideshow' => '5000',
                'smp_lightbox_show_title' => 1,
                'smp_lightbox_opacity' => '0.8',
            );
            foreach($default_options as $name => $value) {
                $current_value = get_option($name);
                if(!$current_value) {
                    add_option($name,$value);
                }
            }
        }
	
	public function smp_front_end_scripts_styles() {
            wp_register_script( 'smp_prettyphoto_script', plugins_url('/prettyPhoto/js/jquery.prettyPhoto.js', __FILE__), 'jquery', '3.1.2' );
            wp_register_style( 'smp-frontend-style', TEMPLATE_URL . 'smugmug.css', false, '1.0' );
            wp_register_style( 'smp-prettyPhoto-style', plugins_url('/prettyPhoto/css/prettyPhoto.css', __FILE__),'3.1.2');
            wp_enqueue_script( 'smp_prettyphoto_script' );
            wp_enqueue_style( 'smp-frontend-style' );
            wp_enqueue_style( 'smp-prettyPhoto-style' );
	}
	
        public function smp_front_footer_script() {
            ?>
            <script type="text/javascript">
              jQuery(function($){
                $("a[rel^='prettyPhoto']").prettyPhoto({
                    animation_speed: '<?php echo get_option( 'smp_lightbox_animation' ); ?>',
                    slideshow: <?php echo (get_option( 'smp_lightbox_slideshow' ) == 0 ? 'false' : get_option('smp_lightbox_slideshow')); ?>,
                    autoplay_slideshow: <?php echo (get_option( 'smp_lightbox_auto_slide' ) == 1 ? 'true' : 'false'); ?>,
                    opacity: <?php echo get_option( 'smp_lightbox_opacity' ); ?>,
                    show_title: <?php echo (get_option( 'smp_lightbox_show_title' ) == 1 ? 'true' : 'false'); ?>,
                    allow_resize: <?php echo (get_option( 'smp_lightbox_allow_resize' ) == 1 ? 'true' : 'false'); ?>,
                    theme: '<?php echo get_option( 'smp_lightbox_template' ); ?>',
                    deeplinking: false,
                    overlay_gallery: <?php echo (get_option( 'smp_lightbox_allow_resize' ) == 1 ? 'true' : 'false'); ?>,
                    keyboard_shortcuts: <?php echo (get_option( 'smp_lightbox_keyboard_shortcuts' ) == 1 ? 'true' : 'false'); ?>
                });
              });
            </script>
            <?php
        }
        function add_settings_link($links, $file) {
            static $this_plugin;
            if (!$this_plugin) $this_plugin = plugin_basename(__FILE__);

            if ($file == $this_plugin){
                $settings_link = '<a href="/wp-admin/admin.php?page=smugmug-settings">'.__("Settings", "smugmug-galleries").'</a>';
            array_unshift($links, $settings_link);
            }
            return $links;
        }
	public function smp_footer_script() {
		?>
		<script type="text/javascript" charset="utf-8">
		function prettyPhoto_init() {
			jQuery("a[rel^='prettyPhoto']").prettyPhoto({
				default_width:600,
				default_height:600,
                                allow_resize: false,
			});
		}
		function prettyLoader_init() {
			jQuery.prettyLoader({
				loader: '/wp-content/plugins/smug-press/prettyLoader/images/prettyLoader/ajax-loader.gif'
			});
		}
                jQuery(function($){
                    prettyPhoto_init();
                    //prettyLoader_init();
                });
		</script>
		<?php
	}
	public function get_current_filename() {
            $currentFile = $_SERVER["SCRIPT_NAME"];
            $parts = Explode('/', $currentFile);
            return end($parts);
        }
	public function admin_init() {

                global $f;
                
                $f = new phpSmug("APIKey=". API_KEY,
                                "AppName=Custom Wordpress Installation / 0.1",
                                "APIVer=1.3.0",
                                "OAuthSecret=".SECRET_KEY);
                
                $token_new = unserialize(get_option('smugpress_access_token'));
                // Set the Access token for use by phpSmug.   
                $f->setToken( "id={$token_new['Token']['id']}", "Secret={$token_new['Token']['Secret']}" );
		//$this->set_api_secret_key();
                
                //$service = $f->service_ping();
                
                //if(!$service) {
                    require_once(PLUGIN_DIR ."controller/admin/forms/forms.php");
                
                    require_once(PLUGIN_DIR ."controller/admin/overview/overview.php");

                    require_once(PLUGIN_DIR ."controller/admin/pagination.php");

                    require_once(PLUGIN_DIR ."controller/admin/settings/settings.php");

                    if(get_option('smugpress_access_token')) {
                            require_once(PLUGIN_DIR ."controller/admin/manage-albums/manage-albums.php");

                            require_once(PLUGIN_DIR ."controller/admin/manage-albums/manage-album/manage-album.php");
                            require_once(PLUGIN_DIR ."controller/admin/manage-albums/create-album/create-album.php");

                            require_once(PLUGIN_DIR ."controller/admin/custom-post-type/custom-post-type.php");
                            require_once(PLUGIN_DIR ."controller/admin/custom-post-type/custom-post-type-forms.php");

                            require_once(PLUGIN_DIR ."controller/admin/categories/categories.php");

                            require_once(PLUGIN_DIR ."controller/frontend/admin.php");

                            require_once(PLUGIN_DIR ."controller/frontend/templates/album-templates.php");
                    }
                //}
		
	}
	
	function load_custom_wp_admin_scripts(){
            wp_deregister_script('jquery_ui');
            wp_register_script('jquery-ui','https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.13/jquery-ui.min.js','jquery','1.8');
        wp_register_script( 'smp_prettyphoto_script', plugins_url('/prettyPhoto/js/jquery.prettyPhoto.js', __FILE__), 'jquery', '3.1.2' );
        wp_register_script( 'smp_prettyloader_script', plugins_url('/prettyLoader/js/jquery.prettyLoader.js', __FILE__), 'jquery', '1.0.1' );
        
        //wp_register_script( 'smp_blockui_script', plugins_url('/js/jquery.blockUI.js', __FILE__), 'jquery', '2.39' );
        wp_register_style( 'jquery-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.1/themes/smoothness/jquery-ui.css' ); 
        wp_register_style( 'smp_pagination_style', plugins_url('/css/pagination.css', __FILE__), false, '2.2' );
        wp_register_style( 'smp_prettyphoto_style', plugins_url('/prettyPhoto/css/prettyPhoto.css', __FILE__), false, '3.1.2' );
        wp_register_style( 'smp_prettyloader_style', plugins_url('/prettyLoader/css/prettyLoader.css', __FILE__), false, '1.0.1' );
        wp_enqueue_script( 'smp_prettyphoto_script' );
        wp_enqueue_script( 'jquery-ui' );
        wp_enqueue_script( 'smp_prettyloader_script' );
        //wp_enqueue_script( 'smp_blockui_script' );
        wp_enqueue_style( 'jquery-style' ); 
        wp_enqueue_style( 'smp_pagination_style' );
        wp_enqueue_style( 'smp_prettyphoto_style' );
        wp_enqueue_style( 'smp_prettyloader_style' );
	}
	
	public function admin_menu() {
		global $manage_albums;
                global $overview;
		add_menu_page('SmugMug for Wordpress','SmugMug', 'manage_options', 'smugmug-plugin', array($overview,'overview_page'),'/wp-content/plugins/smugmug-for-wordpress/smugmug-icon.png');
                add_submenu_page('smugmug-plugin','SmugPress Overview','Overview','manage_options',
            'smugmug-plugin','');
                if(get_option('smugpress_access_token')) {
                    add_submenu_page('smugmug-plugin','Manage Albums | SmugMug','Manage Albums','manage_options',
                    'smugmug-manage-albums',array(&$manage_albums,'smugpress_manage_albums'),10);
                }
                
	}
	
	function class_to_template($class) {
		$classes = explode('_',$class);
		
		foreach($classes as $class) {
			preg_match_all('/[A-Z][^A-Z]*/',$class,$new_classes[]);
		}
		foreach($new_classes as $key => $new_class) {
			$final_classes[] = strtolower(implode('-',$new_class[0]));
		}
		$template_path = implode('/',$final_classes);
		return $template_path;
	}
	function render_template_path($class,$type) {
		if($type) {
			if($type == 'album') {
				$layoutFolder = TEMPLATE_DIR . 'albums/';
			}
		} else {
			$template_path = $this->class_to_template($class);
			$layoutFolder = PLUGIN_DIR . 'view/'.$template_path.'/';
		}
		return $layoutFolder;
	}
	function render($layout=false,$class=false,$type=false)
	{
		
		$this->layoutFolder = $this->render_template_path($class,$type);
		
		//print_r($this->layoutFolder);
		
		// Check if a layout was specified
		if ($layout)
		{
			// Construct the include path for the layout based on the path in the config file
			$filename = $this->layoutFolder . $layout . ".php";
			
			// Check to see if the file exists
			if (is_file($filename))
			{
				// Render the html through a buffer
				ob_start();
					// Include the requested layout, which will echo the variables into the html
					include $filename;
					
					// Assign the results to a variable we can use
					$contents = ob_get_contents();
				ob_end_clean();
				
				echo $contents;
				return true;
			}
			else // The requested layout wasn't there
			{
				echo "Error - the layout requested for rendering html does not exist." . $this->layoutFolder . $layout . '.php';
				return false;
			}
		}
		else // No layout was specified
		{
			echo "Error - no layout was specified";
			return false;
		}
	}
}
global $smp;
$smp = new SmugPress;
